!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (補間計算)
!
!履歴  2016/08/08  竹広真一
!
program ee_mpi_module_transform_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: vx_Data(:,:)    ! 格子データ
  real(8), allocatable :: vx_Data1(:,:)   ! 格子データ
  real(8), allocatable :: ef_Data(:,:)    ! スペクトルデータ

  integer            :: k=2,l=5
  integer            :: np, ip, ierr

 !---- 座標変数など ----
!!$  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: xmin = 0.0d0, xmax=4.0d0
!!$  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0
  real(8), parameter :: ymin = 2.0d0, ymax=4.0d0

  real(8), parameter :: x0 = 2.0/3.0, x1=3.0/5.0d0
  real(8), parameter :: y0 = 1.0/7.0, y1=5.0/9.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_mpi_module_interpolate_test', &
       'ee_mpi_module interpolate function tests')

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(jc(ip),0:im-1))      ! 格子データ
  allocate(vx_Data1(jc(ip),0:im-1))     ! 格子データ
  allocate(ef_Data(-lm:lm,2*kc(ip)))    ! スペクトルデータ

  !------------------- 初期値設定 ----------------------
  vx_Data = sin(k*pi*vx_X) * sin(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(k*pi*x0)*sin(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1)*sin(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(k*pi*vx_X) * cos(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(k*pi*x0)*cos(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1)*cos(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = sin(k*pi*vx_X) * cos(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(k*pi*x0)*cos(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1)*cos(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(k*pi*vx_X) * sin(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(k*pi*x0)*sin(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1)*sin(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = sin(k*pi*vx_X)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(k*pi*x0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(k*pi*vx_X)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(k*pi*x0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(l*pi*y0), Interpolate_ef(ef_Data, x0, y0),&
    'check (x0, y0)')
  call check0d(cos(l*pi*y1), Interpolate_ef(ef_Data, x1, y1),&
    'check (x1, y1)')

  vx_Data = sin(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(l*pi*y0), Interpolate_ef(ef_Data, x0, y0),&
    'check (x0, y0)')
  call check0d(sin(l*pi*y1), Interpolate_ef(ef_Data, x1, y1),&
    'check (x1, y1)')

  vx_Data = 1.0D0
  ef_Data = ef_vx(vx_Data)
  call check0d(1.0D0, Interpolate_ef(ef_Data, x0, y0), 'check (x0, y0)')
  call check0d(1.0D0, Interpolate_ef(ef_Data, x1, y1), 'check (x1, y1)')

  
  call MPI_FINALIZE(IERR)

  call MessageNotify('M','ee_mpi_module_interpolate_test', &
       'ee_mpi_module Interpolate function tests succeeded!')

 stop
contains

  subroutine check0d(var0,sol0,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var0                     ! 判定する配列
    real(8) :: sol0                     ! 誤差
    character(len=*)  :: funcname
    call AssertEqual(      &
      message = funcname,  &
      answer = sol0,       &
      check = var0,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check0d

  subroutine check2d(var,sol,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program ee_mpi_module_transform_test
